package nc.impl.pubdev.pubtool.execmethod;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.SocketException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.net.ftp.FTP;
import org.apache.commons.net.ftp.FTPFile;
import org.apache.commons.net.ftp.FTPSClient;

import nc.pub.tools.Proptool.PropertiesUtil;
import nc.pub.toos.FileTool.ExcelUtil4Server;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.pattern.pub.PubAppTool;
import nccloud.commons.collections.CollectionUtils;

public class FtpsUtil {
	
	private FTPSClient ftpClient;
	private String strencoding = "ISO-8859-1";
	private String ip = ""; // IPַ
	private String userName = ""; // û
	private String userPwd = ""; // 
	private int port = 21; // ˿ں
	private String basePath = ""; // ȡļĴĿ¼

    /**
     * @author longht
     * @param propfilename  ftpļ
     * @param type 1Ӧȡexcelļ
     * @return ΪMap<String,Object> key =ļ  value=Ӧ 
     * @throws Exception 
     * 
     */
	public Map<String, Object>  doFtpReadFile(String propfilename,int type,String path,List<String> filenamelsit) throws Exception {
		Map<String, Object> result =null;
		try {
			ftpConnectSet(propfilename);
			result = readFileList(path,filenamelsit, type);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			throw new Exception(e.getMessage());
		} finally {
			closeServer();
		}
		return result;
	}


	
	//ftpӲ
	private void ftpConnectSet(String propfilename) throws Exception {
		
		ip = PropertiesUtil.getProperty(propfilename, "ftp_ip");
		userName = PropertiesUtil.getProperty(propfilename, "ftp_username");
		userPwd = PropertiesUtil.getProperty(propfilename, "ftp_pwd");
		port = Integer.parseInt(PropertiesUtil.getProperty(propfilename, "ftp_port"));
		basePath = PropertiesUtil.getProperty(propfilename, "ftp_basePath");
		// Եǰϵͳʱƴļ
		this.connectServer(ip, port, userName, userPwd, basePath);
	}

	/**
	 * Ӳ½ftp
	 * @param ip
	 * @param port
	 * @param userName
	 * @param userPwd
	 * @param path
	 * @throws Exception 
	 * @throws SocketException
	 * @throws IOException     function:ӵ
	 */
	private  void connectServer(String ip, int port, String userName, String userPwd, String path) throws Exception {
		ftpClient = new FTPSClient("TLS", true);
		try {
			ftpClient.setDataTimeout(300 * 1000);
			ftpClient.setDefaultTimeout(300 * 1000);
			// 
			ftpClient.connect(ip, port);
			// ¼
			ftpClient.setFileType(FTP.BINARY_FILE_TYPE);
			boolean flag = ftpClient.login(userName, userPwd);
			ftpClient.execPROT("P");//ȡ
			if (path != null && path.length() > 0) {
				// תָĿ¼
				ftpClient.changeWorkingDirectory(path);
				strencoding = ftpClient.getControlEncoding();
			}
		} catch (Exception e) {
			throw new Exception("ftpʧܣ"+e.getMessage());
		} 
	}

	/**
	 * ر
	 * @throws IOException function:ر
	 */
	private void closeServer() {
		if (ftpClient.isConnected()) {
			try {
				ftpClient.logout();
			} catch (IOException e) {
				e.printStackTrace();
			}finally {
				try {
					ftpClient.disconnect();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}
		}
	}

	/**
	 * @param path
	 * @return function:ȡָĿ¼µļ
	 * @throws IOException
	 */
	private Map<String, Object> readFileList(String path,List<String> filenamelsit, int type) throws Exception {
		if(PubAppTool.isNull(path))
			throw new Exception("·Ϊ");
		// 췵ֵ
		Map<String, Object> reDatas = new HashMap<String, Object>();
		// ָĿ¼ļ
		FTPFile[] ftpFiles = null;
		ftpClient.enterLocalPassiveMode();
        //ָĿ¼ļֱӻȡ
		if(!CollectionUtils.isEmpty(filenamelsit)) {
			for (String filename : filenamelsit) {
				ArrayList<ArrayList<Object>> result = readExcelFile(path+filename);
				reDatas.put(filename, result);
			}
		}else {
			for (int i = 0; ftpFiles != null && i < ftpFiles.length; i++) {
				ftpClient.changeWorkingDirectory(path);
				FTPFile file = ftpFiles[i];
				if (file.isFile()) {
					String filename = new String(file.getName().getBytes(strencoding), "GBK").toLowerCase();
					if (1 == type) {
						ArrayList<ArrayList<Object>> result = readExcelFile(file.getName());
						reDatas.put(filename, result);
					}
				}
			}
		}
		return reDatas;
	}

	/**
	 * @param ftpfile
	 * @return function:ӷ϶ȡָļ
	 * @throws ParseException
	 * @throws IOException
	 */
	private ArrayList<ArrayList<Object>> readExcelFile(String ftpfile) {
		ArrayList<ArrayList<Object>> datas = null;
		InputStream ins = null;
		try {
			ftpClient.enterLocalPassiveMode();
			// ӷ϶ȡָļ
			ins = ftpClient.retrieveFileStream(ftpfile);
			if (null == ins)
				return null;
			if (ftpfile.endsWith("xlsx")) {
				// ecxel2007
				datas = new ExcelUtil4Server().readExcel2007(ins);
			} else if (ftpfile.endsWith("xls")) {
				// ecxel2003
				datas = new ExcelUtil4Server().readExcel2003(ins);
			} else if (ftpfile.endsWith("csv")) {
				datas = new ExcelUtil4Server().readCsv(ins);
			} else {
				ExceptionUtils.wrappBusinessException("ʧܣϵͳֻxls,xlsx,csvļ");
				return null;
			}

		} catch (IOException e) {

			e.printStackTrace();
		} finally {
			if (ins != null) {
				try {
					ins.close();
					ftpClient.getReply();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		return datas;
	}

	/**
	 * @param fileName
	 * @return function:ӷ϶ȡָļ
	 * @throws ParseException
	 * @throws IOException
	 */
	private List<String> readFile(String fileName, List<String> list) throws ParseException {
		if (!(null != list && list.size() > 0))
			list = new ArrayList<String>();
		InputStream ins = null;
		try {
			ftpClient.enterLocalPassiveMode();
			// ӷ϶ȡָļ
			ins = ftpClient.retrieveFileStream(fileName);
			if (null == ins)
				return list;
			BufferedReader reader = new BufferedReader(new InputStreamReader(ins, "GBK"));
			String line;
			while ((line = reader.readLine()) != null) {
				line = "," + line;
				line = line.replaceAll(";", ",");
				list.add(line);
			}
			reader.close();
			if (ins != null) {
				ins.close();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		return list;
	}
}
